/*
 * data_server.h
 *
 *  Created on: Sep 12 2016
 *      Author: petrov
 */

/*!
 * \file
 * \brief Заголовочный файл с описанием классов
 *
 * Содержит определения основных классов, необходимых для выполнения тестового задания
 */

#ifndef DATA_SERVER_H_
#define DATA_SERVER_H_

#include <stdint.h>

// containers
#include <map>
#include <set>

// files
#include <fstream>

using namespace std;

#define STORAGE_FILENAME 	"data_"
#define STORAGE_DIRECTORY 	"."


/*!
 * \brief Класс описания Блоба для хранения данных
 *
 * Класс, определяющий логику хранения блоков данных на диске (блоб)
 */
class DataBlob {

public:

	/*!
	 * Конструктор класса
	 *
	 * Данные в блобе хранятся последовательно блоками заданной в конструкторе длины.
	 * Запись блоков происходит последовательно.
	 * Перезапись и удаление данных не предусмотрено в рамках тестового задания.
	 * Чтение блоков происходит посредством вычисления из указанной позиции смещения относительно начала файла.
	 *
	 * \param[in] blockSize размер блока данных
	 * \param[in] blobSize размер блоба данных (в блоках)
	 *
	 */
	DataBlob(uint64_t blockSize, uint32_t blobSize);

	/*!
	 * Деструктор класса
	 */
	~DataBlob();

	/*!
	 * Возвращает блок по указанной позиции в блобе
	 *
	 * \param[in] blockPos позиция блока в блобе
	 * \param[out] blockData указатель на прочитанный блок
	 *
	 * \result результат выполнения операции (не ноль - ошибка)
	 */
	int getBlock(uint64_t blockPos, char* blockData);

	/*!
	 * Помещает блок в блоб
	 *
	 * \param[in] blockData указатель на помещаемый блок
	 *
	 * \result результат выполнения операции (не ноль - ошибка)
	 */
	int putBlock(const char* blockData);

	/*!
	 * Возвращает текущую позицию в блобе
	 *
	 * \result текущая позиция
	 */
	int getPosition();

	/*!
	 * Возвращает имя файла, в который записан текущий блоб
	 *
	 * \result имя файла
	 */
	string getFilename();

	/*!
	 * Открывает файл блоба на диске
	 *
	 * \param[in] fileName имя открываемого файла
	 *
	 * \result результат выполнения операции (не ноль - ошибка)
	 */
	int open(string fileName);

	/// Набор ошибок - результатов выполнения операций
	enum errs {
		SUCCESS, ///< успешное выполнение
		ERR_BLOB_NOT_OPENED = -1, ///< открытие блоба завершилось ошибкой
		ERR_BLOB_IS_RO 		= -2, ///< блоб открыт в режиме только для чтения
		ERR_BLOB_IS_FULL 	= -3 ///< блоб заполнен
	};

private:

	/// Набор состояний блоба
	enum states {
		STATE_NOT_OPENED, ///< файл блоба не открыт
		STATE_RO, ///< файл блоба открыт только для чтения
		STATE_RW ///< файл блоба открыт для чтения и записи
	};

	fstream _fileBlob; /*!< файловый поток */
	uint64_t _blockSize; /*!< размер блока */
	uint32_t _blobSize; /*!< размер блоба */
	string _fileName; /*!< имя файла для хранения блоба */
	unsigned char _state; /*!< текущий статус */
};

/*!
 * \brief Класс описания работы сервера для хранения данных
 *
 * Класс, определяющий логику добавления и извлечения блоков из хранилища.
 *
 * Блоки данных объединяются в логические блобы, которые физически хранятся в файлах на диске.
 * Для обеспечения дедупликации данных на сервере хранятся две таблицы _tableIndex _tableHash.
 * В первой ключ - индекс блока, во второй - хэш данных блока.
 * _tableIndex позволяет производить быстрый поиск средствами C++ по индексу,
 * _tableHash - по хэшу-функции данных блока.
 * Во всех таблицах ключ уникален.
 * Если данные уже присутствуют в хранилище, но индекса добавления в хранилище нет,
 * то в _tableIndex добавляется новый индекс с описанием присутствующего в хранилище блока.
 */
class DataServer {

public:

	/*!
	 * Конструктор класса
	 */
	DataServer();

	/*!
	 * Деструктор класса
	 */
	~DataServer();

	/*!
	 * Инициалирует объект - указывает размер блоба и блока
	 *
	 * \param[in] blockSize размер блока
	 * \param[in] blobSize размеб блоба
	 *
	 * \result результат выполнения операции (не ноль - ошибка)
	 */
	int init(uint64_t blockSize, uint32_t blobSize);

	/*!
	 * Добавляет блок данных в хранилище
	 *
	 * \param[in] blockId идентификатор блока
	 * \param[in] blockData указатель на блок данных
	 *
	 * \result результат выполнения операции (не ноль - ошибка)
	 */
	int putBlock(uint64_t blockId, const char* blockData);

	/*!
	 * Извлекает блок данных из хранилища
	 *
	 * \param[in] blockId идентификатор блока
	 * \param[in] blockData указатель на блок данных
	 *
	 * \result результат выполнения операции (не ноль - ошибка)
	 */
	int getBlock(uint64_t blockId, char* blockData);

	/// Набор ошибок - результатов выполнения операций
	enum errs {
		SUCCESS, ///< успешное выполнение
		ERR_ALREADY_INITIALIZED	= -1, ///< хранилище уже инициализировано
		ERR_BLOCK_ID_EXIST 		= -2, ///< блок с таким ID уже существует
		ERR_BLOCK_DATA_EXIST 	= -3, ///< блок с такими данными уже существует
		ERR_BLOCK_ID_NOT_EXIST 	= -4 ///< блок с таким ID не найден
	};

private:

	/// Описание блока данных
	struct blockDesc {
		size_t hash; ///< хэш-функция данных блока
		string fileName; ///< имя файла, в котором хранится блок
		uint64_t position; ///< позиция блока в файле
	};

	map<uint64_t, blockDesc> _tableIndex; /*!< таблица хранимых индексов блоков (пара индекс - описание блока blockDesc)*/
	map<size_t, uint64_t> _tableHash; /*!< таблица хэш-функций хранимых блоков (пара хэш - индекс блока) */

	uint64_t _blockSize; /*!< размер блока */
	uint32_t _blobSize; /*!< размер блоба */

	DataBlob *_wBlob; /*!< указатель на блоб для записи данных */
	DataBlob *_rBlob; /*!< указатель на блоб для чтения данных */

	string _rBlobFileName; /*!< имя файла блоба для чтения данных */
	uint32_t _wBlobCount; /*!< счетчик записанных блобов */
};

#endif /* DATA_SERVER_H_ */
